#include "settings.h"
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>

int HOR=0;
int VER=0;

enum {
        LIST_ITEM = 0,
        N_COLUMNS
        };

char SearchDir[1024];

// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// hexcleaner
// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

int     hexcleaner(char *t) {

        char _ftmp[1024];
        int m,n=0,p,f=0;

        for(m=0; t[m]; m++) {

                if (t[m] < 32 || t[m] >127 ) { f=1; continue; }

                if (t[m]=='%') {

                        f=1;
                        if (t[m+1] >= 'a' && t[m+1] <= 'z') t[m+1] = t[m+1]-32;
                        if (t[m+1] >= '0' && t[m+1] <= '9') p=( t[m+1]-'0' ) * 16;
                                else p=(t[m+1]-'A'+10)*16;

                        if (t[m+2] >= 'a' && t[m+2] <= 'z') t[m+2] = t[m+2]-32;
                        if (t[m+2] >= '0' && t[m+2] <= '9') p = p+(t[m+2]-'0');
                                else p=p+(t[m+2]-'A'+10);

                        _ftmp[n]=p;  /* insert value into output string */
                        n++; m=m+2;
                        }

                else {
                        _ftmp[n++]=t[m];
                        }
                }

        _ftmp[n]=0;
        strcpy(t,_ftmp);
        return f;
        }


void on_changed(GtkWidget *widget, gpointer label) {

	GtkTreeIter iter;
	GtkTreeModel *model;
	gchar *value;
	static int i=0;

	if (gtk_tree_selection_get_selected( GTK_TREE_SELECTION(widget), &model, &iter)) {
	
		gtk_tree_model_get(model, &iter, LIST_ITEM, &value,  -1);
		printf("%s\n",(char *) value);
		exit(EXIT_SUCCESS);
		}
	}

void init_list(GtkWidget *list) {

        GtkCellRenderer *renderer;
        GtkTreeViewColumn *column;
        GtkListStore *store;

        renderer = gtk_cell_renderer_text_new ();

        column = gtk_tree_view_column_new_with_attributes("List Items", renderer, "text", LIST_ITEM, NULL);

        gtk_tree_view_append_column(GTK_TREE_VIEW(list), column);

        store = gtk_list_store_new(N_COLUMNS, G_TYPE_STRING);

        gtk_tree_view_set_model(GTK_TREE_VIEW(list), GTK_TREE_MODEL(store));

        g_object_unref(store);
        }

void add_to_list(GtkWidget *list, const gchar *str) {

	GtkListStore *store;
	GtkTreeIter iter;

	store = GTK_LIST_STORE( gtk_tree_view_get_model(GTK_TREE_VIEW(list)) );

	gtk_list_store_append(store, &iter);
	gtk_list_store_set(store, &iter, LIST_ITEM, str, -1);
	}

static void activate (gpointer user_data) {

	GtkWidget *window;
	GtkWidget *scrolled_window;
	GtkWidget *image;
	GtkWidget *list;
	GtkTreeSelection *selection;
	int i=0,j;
	FILE * p1;
	char msg1[1024],cmd[1025];

//---------------------------------------------------------------------
//      establish home directory for music
//---------------------------------------------------------------------

	gtk_init(0,NULL);
        window = gtk_window_new(GTK_WINDOW_TOPLEVEL);

	gtk_window_set_title (GTK_WINDOW (window), "Search Window");
	gtk_window_set_default_size (GTK_WINDOW (window), 400, 400);

	scrolled_window = gtk_scrolled_window_new (NULL, NULL);

	gtk_container_set_border_width (GTK_CONTAINER (scrolled_window), 10);

        g_signal_connect(G_OBJECT (window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

	list = gtk_tree_view_new();

	init_list(list);

	if ( ((char *) user_data)[0] == '!' ) {

        	sprintf(cmd, "find \"%s\" | grep -i \"%s\" ", SearchDir, ((char *) user_data)+1);
        	sprintf(msg1, "Searching for: \"%s\" " , (char *) user_data);
		add_to_list(list, msg1);
		}
	else {

        	sprintf(cmd, "grep -i \"%s\" %s/tmp", ((char *) user_data), SearchDir);
        	sprintf(msg1, "Searching for: \"%s\" " , (char *) user_data);
		add_to_list(list, msg1);
		}

        p1=popen(cmd,"r"); // run command are read result from pipe p1

        while(1) {
                i++;
                if (i>40) {
			strcpy(cmd,"First 40 shown");
                	add_to_list(list, cmd);
			break;
                        }
                if (fgets(cmd,1024,p1)==NULL) break;
                cmd[strlen(cmd)-1]=0;
//		for (j=0; cmd[j]!=0; j++) if (cmd[j]==' ') break;
//		j++;
		j=0;
                add_to_list(list, &cmd[j]);
                }

        if (i==1) add_to_list(list, "<none found>");
        fclose(p1);

	gtk_container_add (GTK_CONTAINER (scrolled_window), list);

	gtk_scrolled_window_set_policy (GTK_SCROLLED_WINDOW (scrolled_window),
                                  GTK_POLICY_AUTOMATIC,
                                  GTK_POLICY_AUTOMATIC);

	gtk_container_add (GTK_CONTAINER (window), scrolled_window);

	gtk_widget_show_all (window);
        g_signal_connect(G_OBJECT (window), "destroy", G_CALLBACK(gtk_main_quit), NULL);

	selection = gtk_tree_view_get_selection(GTK_TREE_VIEW(list));
        g_signal_connect(selection, "changed", G_CALLBACK(on_changed), NULL);

        gtk_widget_show_all(window);
        gtk_window_resize(GTK_WINDOW(window), 550, 720);	// width, height

	gtk_window_move (GTK_WINDOW(window), 0, 0);
	gtk_window_set_keep_above(GTK_WINDOW(window),TRUE);

	gtk_main();
	}

int main (int argc, char **argv) {

	char srch[1024];

	if (argc!=5) return EXIT_FAILURE;

	strcpy(SearchDir,argv[1]);
	strcpy(srch,argv[2]);

// -------------------------------------------------------------------------------
// configuration file input
// -------------------------------------------------------------------------------

	sscanf(argv[3],"%d",&HOR);
	sscanf(argv[4],"%d",&VER);

	activate((gchar *) srch);

	return EXIT_SUCCESS;
	}
